//@***h* BDBP/gb_excelutils.pas
// 
// NAME
//   gb_excelutils.pas
//
// PURPOSE
//  Deals with reading in data from Excel files. 
//
// DESCRIPTION
//  This unit deals with reading in data from Excel files. 
//  
// AUTHOR
//  Birgit Hassler, CIRES / NOAA ESRL CSD
//
// COPYRIGHT 
//   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
//   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
//   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
//   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
//   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
//   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
//   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
//   SUPPORT TO USERS.
//
// REVISION HISTORY
//   6/16/2014 Initial Version prepared for NCDC.
// 
//@***** 


unit gb_excelutils;

{$I UNITDIREC.INC}

interface

function ConvertExcelColToNum(ColStr:string):integer;
function ConvertExcelNumToCol(ColNum:integer):string;

implementation

uses
  Math;

function ConvertExcelColToNum(ColStr:string):integer;
begin
  Result:=-1;
  if length(ColStr)=1 then Result:=ord(UpCase(ColStr[1]))-65;
  if length(ColStr)=2 then Result:=(ord(UpCase(ColStr[1]))-64)*26+(ord(UpCase(ColStr[2]))-65);
  if length(ColStr)=3 then Result:=(ord(UpCase(ColStr[1]))-64)*26*26+
    (ord(UpCase(ColStr[2]))-64)*26+(ord(UpCase(ColStr[3]))-65);
end;

function ConvertExcelNumToCol(ColNum:integer):string;
var
  X:integer;
begin
  if ColNum<27 then Result:=chr(64+Colnum);
  if ((ColNum>=27) and (ColNum<703)) then
    Result:=chr(64+((ColNum-1) div 26))+chr(65+((ColNum-1) mod 26));
  if ((ColNum>=703) and (ColNum<18252)) then
  begin
    X:=ColNum div 702;
    Result:=chr(64+X);
    ColNum:=ColNum-(X*702);
    Result:=Result+chr(65+((ColNum-1) div 26))+chr(65+((ColNum-1) mod 26));
  end;
end;

end.
